//
//  MySessionHandler.swift
//  SampleApp
//
//  Created by Nutchaphon Rewik on 16/11/2565 BE.
//  Copyright © 2565 BE David Zhang. All rights reserved.
//

import Foundation
import AmitySDK

class MySessionHandler: SessionHandler {
    
    func sessionWillRenewAccessToken(renewal: AmitySDK.AccessTokenRenewal) {
        print("sdk will renew access token")
        guard let currentUserId = AmityManager.shared.client?.currentUserId else {
            assertionFailure("something went wrong, currentUserId must have a value")
            return
        }
        if AmityManager.shared.needsAuthToken {
            Task { @MainActor in
                do {
                    let authToken = try await AmityManager.shared.getAuthToken(userId: currentUserId)
                    renewal.renewWithAuthToken(authToken: authToken)
                } catch {
                    renewal.unableToRetrieveAuthToken()
                }
            }
        } else {
            renewal.renew()
        }
    }
    
}
