//
//  SessionStateLogPage.swift
//  SampleApp
//
//  Created by Nutchaphon Rewik on 22/11/2565 BE.
//  Copyright © 2565 BE David Zhang. All rights reserved.
//

import SwiftUI
import AmitySDK

struct SessionStateLogPage: View {
    
    var body: some View {
        List(AmityManager.shared.sessionStateLog.reversed()) { record in
            VStack(alignment: .leading) {
                Text("\(record.value.colorEmoji) \(record.value.description)").font(.body)
                if #available(iOS 15.0, *) {
                    Text(record.timestamp.formatted(
                        .iso8601
                            .day()
                            .month()
                            .year()
                            .time(includingFractionalSeconds: true))
                    )
                    .font(.caption)
                    .foregroundColor(Color.gray)
                }
            }
        }
    }
    
}

struct SessionStateLogPage_Previews: PreviewProvider {
    static var previews: some View {
        SessionStateLogPage()
    }
}
