//
//  TestController.swift
//  SampleApp
//
//  Created by Nishan Niraula on 10/15/20.
//  Copyright © 2020 David Zhang. All rights reserved.
//

import Foundation
import UIKit
import AmitySDK

// NOTE:
// Ignore stuffs in this class. This class is just for quick testing of sdk stuffs inside sample app.
@MainActor
class TestController: UIViewController {
    
    let client = AmityManager.shared.client!
    
    var token: AmityNotificationToken?
    
    let userRepo = AmityUserRepository(client: AmityManager.shared.client!)
    let commRepo = AmityCommunityRepository(client: AmityManager.shared.client!)
    let commentRepo = AmityCommentRepository(client: AmityManager.shared.client!)
    let postRepo = AmityPostRepository(client: AmityManager.shared.client!)
    let channelRepo = AmityChannelRepository(client: AmityManager.shared.client!)
    let messageRepo = AmityMessageRepository(client: AmityManager.shared.client!)
    let fileRepo = AmityFileRepository(client: AmityManager.shared.client!)
    let subChannelRepo = AmitySubChannelRepository(client: AmityManager.shared.client!)
    let reactionRepo = AmityReactionRepository(client: AmityManager.shared.client!)
    
    var messageEditor: AmityMessageEditor?
    var messageFlagger: AmityMessageFlagger?
    
    
    override func loadView() {
        view = UIView()
        view.backgroundColor = .white
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        AmityLog.logLevel = .all
        
        let button1 = UIBarButtonItem(title: "A1", style: .plain, target: self, action: #selector(onButton1Tap))
        let button2 = UIBarButtonItem(title: "A2", style: .plain, target: self, action: #selector(onButton2Tap))
        let button3 = UIBarButtonItem(title: "A3", style: .plain, target: self, action: #selector(onButton3Tap))
        let button4 = UIBarButtonItem(title: "A4", style: .plain, target: self, action: #selector(onButton4Tap))
        
        self.navigationItem.rightBarButtonItems = [button1, button2, button3, button4]
    }

    @objc func onButton1Tap() {

    }
    
    @objc func onButton2Tap() {

    }
    
    @objc func onButton3Tap() {
        
    }

    @objc func onButton4Tap() {
    
    }
    
//
//    func uploadImageFile() {
//        let imageFile = UIColor.red.asImage(size: CGSize(width: 200, height: 200))
//        Task { @MainActor in
//            do {
//                let result = try await fileRepo.uploadImage(imageFile, progress: nil)
//                Log.add(info: "File Uploaded!. FileId: \(result.fileId)")
//                self.fileId = result.fileId
//            } catch {
//                Log.add(info: "File upload error: \(error.localizedDescription)")
//            }
//        }
//    }
//
//    func createImageComment() {
//        let commentBuilder = AmityCommentCreateOptions(referenceId: postId, referenceType: .post, text: "Image Comment - 1", attachments: [.image(fileId: fileId)])
//
//        Task { @MainActor in
//            do {
//                let comment = try await commentRepo.createComment(with: commentBuilder)
//
//                Log.add(info: "Comment Created!. Comment Id: \(comment.commentId)")
//                self.commentId = comment.commentId
//                Log.add(info: "Data Types: \(comment.dataTypes)")
//
//                let attachments = comment.attachments
//                for attachment in attachments {
//                    switch attachment {
//                    case .image(let fileId, let data):
//                        Log.add(info: "Image FileId: \(fileId)")
//                        Log.add(info: "Image Data: \(String(describing: data?.attributes))")
//                    @unknown default:
//                        Log.add(info: "Attachment Types Not Available")
//                    }
//                }
//            } catch {}
//        }
//    }
//
//    func getUserInput(completion: @escaping (String, String) -> Void) {
//        let alert = UIAlertController(title: "Assign Role", message: "", preferredStyle: .alert)
//        alert.addAction(UIAlertAction(title: "Cancel", style: .cancel, handler: nil))
//        alert.addTextField { (textField) in
//            textField.placeholder = "User Id"
//            textField.autocapitalizationType = .none
//        }
//        alert.addTextField { (textField) in
//            textField.autocapitalizationType = .none
//            textField.placeholder = "Input"
//        }
//        alert.addAction(UIAlertAction(title: "Submit", style: .default, handler: { (action) in
//            guard let id = alert.textFields?[0].text, let role = alert.textFields?[1].text, !id.isEmpty, !role.isEmpty else { return }
//            completion(id, role)
//        }))
//        self.present(alert, animated: true, completion: nil)
//    }
}
